<?php
// $Id: xoopsstory.php,v 1.10 2003/04/01 22:51:21 mvandam Exp $
//  ------------------------------------------------------------------------ //
//                XOOPS - PHP Content Management System                      //
//                    Copyright (c) 2000 XOOPS.org                           //
//                       <http://www.xoops.org/>                             //
//  ------------------------------------------------------------------------ //
//  This program is free software; you can redistribute it and/or modify     //
//  it under the terms of the GNU General Public License as published by     //
//  the Free Software Foundation; either version 2 of the License, or        //
//  (at your option) any later version.                                      //
//                                                                           //
//  You may not change or alter any portion of this comment or credits       //
//  of supporting developers from this source code or any supporting         //
//  source code which is considered copyrighted (c) material of the          //
//  original comment or credit authors.                                      //
//                                                                           //
//  This program is distributed in the hope that it will be useful,          //
//  but WITHOUT ANY WARRANTY; without even the implied warranty of           //
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the            //
//  GNU General Public License for more details.                             //
//                                                                           //
//  You should have received a copy of the GNU General Public License        //
//  along with this program; if not, write to the Free Software              //
//  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307 USA //
//  ------------------------------------------------------------------------ //
// Author: Kazumi Ono (AKA onokazu)                                          //
// URL: http://www.myweb.ne.jp/, http://www.xoops.org/, http://jp.xoops.org/ //
// Project: The XOOPS Project                                                //
// ------------------------------------------------------------------------- //
include_once XOOPS_ROOT_PATH."/mainfile.php";
include_once XOOPS_ROOT_PATH."/class/database/database.php";

class DiaryStory
{
	var $table;
	var $storyid;
	var $uid;
	var $title;
	var $bodytext;
	var $nosmily;
	var $nohtml;
	var $db;
	var $comments;
	var $dtime;
	var $ddate;


	function DiaryStory($sid = -1)
	{
		$this->db =& Database::getInstance();
		$this->table = "";
		$this->storyid = -1;
		if ( is_array($sid) ) {
			$this->makeStory($sid);
		} elseif ( $sid != -1 ) {
			$this->storyid = $sid;
			$ar = $this->getEachStoryRaw(intval($this->storyid));
			$this->title = $ar['title'];
			$this->nosmily = intval($ar['nosmily']);
			$this->nohtml = intval($ar['nohtml']);
			$this->ddate = $ar['ddate'];
			$this->dtime = $ar['dtime'];
			$this->bodytext = $ar['bodytext'];
			$this->comments = $ar['comments'];
			$this->uid = intval($ar['uid']);
		}
	}

	function setTitle($s = ""){
		$this->title = $s;
	}
	
	function setBodyText($s = ""){
		$this->bodytext = $s;
	}

	function setDDate($s = ""){
		$this->ddate = $s;
	}
	
	function setNosmily($flg = 0){
		$this->nosmily = $flg;
	}
	
	function setNohtml($flg = 0){
		$this->nohtml = $flg;
	}
	
	function setStoryID($id = 0){
		$this->storyid = $id;
	}

	function setUserID($id = 0){
		$this->uid = $id;
	}

	function nosmily(){
		return($this->nosmily);
	}

	function nohtml(){
		return($this->nohtml);
	}

	function getDateList($start=nulll,$cnt=5)
	{
		if($start == null){
			$start = "NOW()";
		}
		else{
			$start =  "'" . $start . "'";
		}
		$sql = "SELECT ddate FROM ".$this->db->prefix('admindiary_stories_tbl')." WHERE  ddate <= " . $start  . " GROUP BY ddate ORDER BY ddate DESC LIMIT "  . $cnt;  
		$q  = $this->db->query($sql);
		$diary = array();

		while($a = $this->db->fetchArray($q)){
			$diary[] = array_shift($a);
		}
		
		return ($diary);
	
	}

	function sanitizeStory($src){
		$myts =& MyTextSanitizer::getInstance();
		$dst = array();
		$smily = 1;
		$html = 1;
		if(intval($src['nosmily']) == 1){
			$smily = 0;
		}
		if(intval($src['nohtml']) == 1){
			$html = 0;
		}
		foreach(array_keys($src) as $key){
			switch($key){
				case 'nosmily' :
				case 'nohtml' :
					break;
				case 'bodytext' :
				case 'title' :
					
					$dst[$key] = $myts->makeTareaData4Show($src[$key],$html, $smily, 1);
					break;
				default:
					$dst[$key] = $src[$key];
			}
		}
		return($dst);
	}


	function store()
	{
		$myts =& MyTextSanitizer::getInstance();
		$ttl =$myts->censorString($this->title);
		$ttl = $myts->makeTboxData4Save($ttl);
		$btext =$myts->censorString($this->bodytext);
		$btext = $myts->makeTareaData4Save($btext);
		if ( !isset($this->nosmily) || $this->nosmily != 1 ) {
			$this->nosmily = 0;
		}

		if ( !isset($this->nohtml) || $this->nohtml != 1 ) {
			$this->nohtml = 0;
		}
		if ( $this->storyid < 0 ){
			$sql = sprintf("INSERT INTO  ".$this->db->prefix('admindiary_stories_tbl')." (title,uid,ddate,dtime,nohtml,nosmily,bodytext) VALUES ('%s',%u,NOW(),NOW(),%u,%u,'%s')", $ttl,$this->uid,$this->nohtml, $this->nosmily, $btext);
		} 
		else
		{
			$sql = sprintf("UPDATE  ".$this->db->prefix('admindiary_stories_tbl')." SET title = '%s',bodytext = '%s',nohtml = %u,nosmily = %u  WHERE storyid = %d ",$ttl, $btext,$this->nohtml,$this->nosmily, $this->storyid);
			$newstoryid = $this->storyid;
		}
		if (!$result = $this->db->queryF($sql)) {
			return false;
		}
		if ( empty($newstoryid) ) {
			$newstoryid = $this->db->getInsertId();
			$this->storyid = $newstoryid;
		}
		return $newstoryid;
	}

	function getEachStory($sid = -1)
	{			
		if($sid < 0){
			$sid = $this->storyid;
		}
		$sql = "SELECT * FROM  ".$this->db->prefix('admindiary_stories_tbl')." WHERE storyid =" . $sid;
		$array = $this->db->fetchArray($this->db->query($sql));
		return($this->sanitizeStory($array));
	}

	function getEachStoryRaw($sid = -1)
	{			
		if($sid < 0){
			$sid = $this->storyid;
		}
		$sql = "SELECT * FROM  ".$this->db->prefix('admindiary_stories_tbl')." WHERE storyid =" . $sid;
		$array = $this->db->fetchArray($this->db->query($sql));
		return($array);
	}

	function comments($sid = -1)
	{			
		if($sid < 0){
			$sid = $this->storyid;
		}
		$sql = sprintf("SELECT comments FROM ".$this->db->prefix('admindiary_stories_tbl')." WHERE storyid=%u",$sid);
		$array = $this->db->fetchRow($this->db->query($sql));
		if(is_null($array)){
			return(0);
		}
		return(intval($array[0]));
	}

	function getDiary($ymd = null){
		$diary = array();

		$ymd = ($ymd) ? "'" . $ymd . "'" : "NOW()";
		$sql = sprintf("SELECT * FROM %s WHERE ddate = %s ",$this->db->prefix('admindiary_stories_tbl'),$ymd);
		$q  = $this->db->query($sql);
 
		while($src = $this->db->fetchArray($q)){
			$diary[] =  $this->sanitizeStory($src);

		}

		return ($diary);
	}

	function makeStory($array)
	{
		foreach ( $array as $key=>$value ){
			$this->$key = $value;
		}
	}
	
	function delete()
	{
		$sql = sprintf("DELETE FROM ".$this->db->prefix('admindiary_stories_tbl')." WHERE storyid = %u", $this->storyid);
		if( !$result = $this->db->query($sql) ) {
			return false;
		}
		return true;
	}

	function title($format="Show")
	{
		$myts =& MyTextSanitizer::getInstance();
		$smily = 1;
		if ( $this->nosmily ) {
			$smily = 0;
		}
		$html = 1;
		if ( $this->nohtml ) {
			$html = 0;
		}
		switch ( $format ) {
		case "Show":
			$title = $myts->makeTboxData4Show($this->title,$html,$smily);
			break;
		case "Edit":
			$title = $myts->makeTboxData4Edit($this->title);
			break;
		case "Preview":
			$title = $myts->makeTboxData4Preview($this->title,$html,$smily);
			break;
		case "InForm":
			$title = $myts->makeTboxData4PreviewInForm($this->title);
			break;
		}
		return $title;
	}

	function bodytext($format="Show")
	{
		$myts =& MyTextSanitizer::getInstance();
		$smily = 1;
		$xcodes = 1;

		if ( $this->nosmily) {
			$smily = 0;
		}
		$html = 1;
		if ( $this->nohtml ) {
			$html = 0;
		}
		switch ( $format ) {
		case "Show":
			$bodytext = $myts->makeTareaData4Show($this->bodytext,$html,$smily,$xcodes);
			break;
		case "Edit":
			$bodytext = $myts->makeTareaData4Edit($this->bodytext);
			break;
		case "Preview":
			$bodytext = $myts->makeTareaData4Preview($this->bodytext,$html,$smily, $xcodes);
			break;
		case "InForm":
			$bodytext = $myts->makeTareaData4PreviewInForm($this->bodytext);
			break;
		}
		return $bodytext;
	}

	function updateComments($total){

		
		$sql = sprintf("UPDATE ".$this->db->prefix('admindiary_stories_tbl')." SET comments=%u WHERE storyid = %u", $total,$this->storyid);
		if( !$result = $this->db->queryF($sql) ) {
			return false;
		}
		return true;
	}

}
?>
